#!/usr/bin/perl

use strict;
use warnings;
use numtoip;
use DBI;
use CDB_File;

# $Id: process_data.pl 84 2007-12-19 23:09:23Z ed $
# $URL: svn+ssh://fw/repos/code/apache2_modules/cidr/process_data.pl $

my $dbh = DBI->connect( "dbi:SQLite:dbname=ipv4.sqlite", "", "" );
my $cdb = CDB_File->new( "ipv4.cdb", "ipv4.cdb.tmp" );
my $cdbc = CDB_File->new( "ipv4_cidr.cdb", "ipv4_cidr.cdb.tmp" );

sub selects {
	my $ip = numtoip->new();
	my $sql = "select * from cidr";
	my $sth = $dbh->prepare($sql) or die( "cannot: $!" );
	$sth->execute() or die( "Cannot: $!" );
	while( my $hr = $sth->fetchrow_hashref() ) { 
		my %h = %$hr;
		print( $ip->binary_num( $h{'cidr_subnet'} ) . "\n" );
	}
}

my $ip = numtoip->new;

my $num = $ip->iptonum( "212.22.96.0" );
print( $ip->binary_num( $num ) . "\n" );
$num += 8190;
print( $ip->binary_num( $num ) . "\n" );

$ip->increase_network( $ip->iptonum( "212.22.96.250" ),  24 );


#print( $ip->binary_num( ~(8192-1) ) . "\n" );
#
#print( ~(8192-1) . "\n" );
#exit;

# CREATE TABLE cidr ( cidr_id bigint auto_increment, cidr_network unsigned int, cidr_subnet unsigned int, cidr_rir tinyint, cidr_cc varchar(20), primary key (cidr_id) );

my $sql = "insert into cidr ( cidr_network, cidr_subnet,
	cidr_rir, cidr_cc ) values ( ?, ?, ?, ? )";

#$dbh->do( "create table if not exists cidr ( cidr_id bigint
#auto_increment, cidr_network unsigned int, cidr_subnet unsigned int,
#cidr_rir tinyint, cidr_cc varchar(20), primary key (cidr_id) );" );

$dbh->do( " create table if not exists cidr ( cidr_id integer primary
key autoincrement, cidr_network unsigned int, cidr_subnet unsigned int,
cidr_rir varchar, cidr_cc varchar(20) ); " );

$dbh->do( "begin" );

foreach my $f ( qw( afrinic apnic arin lacnic ripe rfc1918 ) ) {
	open( F, "files/$f.txt" ) or die( "cannot open $f:$!" );
	while( <F> ) {
		my @p = split( /\x7c/ );
		next if scalar @p != 7;
		next if lc $p[2] ne "ipv4";
		#my $mask = ( 2**32 ) | ( ~( $p[4] - 1 ) );
		#my $mask = ~( $p[4] - 1 );
		#print( $ip->binary_num( $mask ) . "\n" );
		my $num = $ip->iptonum( $p[3] );
		# my $mask = $ip->binary_num( $ip->subnet_from_range( $p[4] ) );
		my $sth = $dbh->prepare( $sql );
		my $mask = $ip->subnet_from_range( $p[4] );

	#	$sth->bind_param( 1, $num, { TYPE => 3 } );
	#	$sth->bind_param( 2, $mask, { TYPE => 4 } );
	#	$sth->bind_param( 3, 'ripe' );
	#	$sth->bind_param( 4, $p[1], { TYPE => 12 } );
	#	$sth->execute();
		$num += 0;

		my $ip_remaining = $p[4];
		my $network_area = $num;

		while( $ip_remaining > 0 ) {
			my $mask_size = $ip->slash_from_netmask( $ip_remaining );
			my $size_of_mask = 2 ** ( 32 - $mask_size );

			if( $size_of_mask != $p[4] ) {
				print( $ip->numtoip($network_area) . ": $size_of_mask($mask_size) is not ${p[4]}\n" );
			}
			
			$cdb->insert( $network_area, "$mask\0$f\0$p[1]" );

			$network_area = $ip->increase_network( $network_area, $mask_size );
			$ip_remaining = $ip_remaining - $size_of_mask;

			#if( ( 2 ** ( 32 - $mask_size ) ) < $p[4] ) {
			#	
			#}
		}

		$cdbc->insert( "$num/" . 
			$ip->slash_from_netmask($p[4]), 
			"$mask\0$f\0$p[1]" );

		#$sth->execute( $num, $mask, 1, $p[1] );
	}
}

#selects(); exit;

$dbh->do( "commit" );
$cdb->finish();
$cdbc->finish();

