#!/usr/bin/perl

use strict;
use warnings;
use DBI;
use numtoip;
use CDB_File;

my $dbh = DBI->connect( "dbi:SQLite:dbname=ipv4.sqlite", "", "" );
tie( my %ipv4, "CDB_File", "ipv4.cdb" ) or
	die( "cannot connect file: $!" );

sub process {
	my $ip_addr = shift;
	my $ip = numtoip->new();

	my $num = $ip->iptonum( $ip_addr );
	my $sql = "select * from cidr where cidr_network = ?";
	my $sth = $dbh->prepare($sql);

	for( my $i=0 ; $i < 32 ; $i ++ ) {
		my $j = 0 + ( 1 << $i ) -1;
		print( $ip->binary_num( ~$j ) . "\n" );
		$num = $num & ~$j;
		$sth->execute( $num );
		while( my $hr = $sth->fetchrow_hashref() ) {
			my %h = %$hr;

			print( $ip->numtoip( $h{'cidr_network'} ) . "\n" );
		}
		$sth->finish();
	}
}

sub cdb_process {
	my $ip_addr = shift;
	my $ip = numtoip->new();
	my $num = $ip->iptonum( $ip_addr );
	
	for( my $i=0 ; $i < 32 ; $i ++ ) {
		my $j = 0 + ( 1 << $i ) -1;
		print( $ip->binary_num( ~$j ) . "\n" );
		$num = $num & ~$j;
		if( defined( $ipv4{$num} ) ) {
			my @a = split( /\0/, $ipv4{$num} );
			
			my $ip_str = $ip->numtoip( $num );
			
			print( "$ip_str ${a[0]} ${a[1]} ${a[2]}\n" );
		}
	}

}

my $ip = numtoip->new;

print( $ip->iptonum(  "81.110.242.129" ) . "\n" );
print( $ip->
exit;

#process( "81.110.242.129" );
cdb_process( "81.110.242.129" );



